#ifndef ROOT_TVirtualTreePlayer
#define ROOT_TVirtualTreePlayer

//+SEQ,CopyRight,T=NOINCLUDE.

//////////////////////////////////////////////////////////////////////////
//                                                                      //
// TVirtualTreePlayer                                                  //
//                                                                      //
// Abstract base class for Histogram pplayers                           //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


#ifndef ROOT_TClass
//*KEEP,TClass.
#include "TClass.h"
//*KEND.
#endif

class TTree;
class TH1;
class TTreeFormula;
class TSlave;

class TVirtualTreePlayer : public TObject {


private:
   static TClass   *fgPlayer; //Pointer to Tree player

public:
    TVirtualTreePlayer() { }
    virtual ~TVirtualTreePlayer() { }
    virtual void           DrawSelect(const Text_t *varexp, const Text_t *selection, Option_t *option
                            ,Int_t nentries, Int_t firstentry) = 0;
    virtual void           Fit(const Text_t *formula ,const Text_t *varexp, const Text_t *selection,Option_t *option ,Option_t *goption
                            ,Int_t nentries, Int_t firstentry) = 0;
    virtual TH1           *GetHistogram() = 0;
    virtual void           GetNextPacket(TSlave *sl, Int_t &nentries, Stat_t &firstentry, Stat_t &processed) = 0;
    virtual Int_t          GetSelectedRows() = 0;
    virtual TTreeFormula  *GetSelect() = 0;
    virtual TTreeFormula  *GetVar1() = 0;
    virtual TTreeFormula  *GetVar2() = 0;
    virtual TTreeFormula  *GetVar3() = 0;
    virtual TTreeFormula  *GetVar4() = 0;
    virtual Float_t       *GetV1() = 0;
    virtual Float_t       *GetV2() = 0;
    virtual Float_t       *GetV3() = 0;
    virtual Double_t      *GetW() = 0;
    virtual void           Loop(Option_t *option,Int_t nentries, Int_t firstentry) = 0;
    virtual Int_t          MakeClass(const char *classname) = 0;
    virtual Int_t          MakeCode(const char *filename) = 0;
    virtual void           Scan(const Text_t *varexp, const Text_t *selection, Option_t *option
                            ,Int_t nentries, Int_t firstentry) = 0;
    virtual void           SetEstimate(Int_t n) = 0;
    virtual void           SetPacketSize(Int_t) = 0;
    virtual void           SetTree(TTree *t) = 0;
    virtual void           StartViewer(Int_t ww, Int_t wh) = 0;

   static  TVirtualTreePlayer *TreePlayer(TTree *obj);
   static void        SetPlayer(const char *player);

    ClassDef(TVirtualTreePlayer,0)  //Abstract interface for Tree players
};

#endif
