//*CMZ :  1.00/06 23/03/97  11.51.59  by  Rene Brun
//*-- Author :    Valery Fine   27/01/96

//*KEEP,CopyRight,T=C.
/*************************************************************************
 * Copyright(c) 1995-1999, The ROOT System, All rights reserved.         *
 * Authors: Rene Brun and Fons Rademakers.                               *
 *                                                                       *
 * For the licensing terms see $ROOTSYS/AA_LICENSE.                      *
 * For the list of contributors see $ROOTSYS/AA_CREDITS.                 *
 *************************************************************************/
//*KEND.

//*KEEP,TGWin32Marker.
#include "TGWin32Marker.h"
//*KEND.

//______________________________________________________________________________
TGWin32Marker::TGWin32Marker(int n, TPoint *xy, int type){
  fNumNode = n;
  fMarkerType = type;
  if (type >= 2)
     if (fChain = new POINT[n])
      for( int i = 0; i < n; i++ ) {
                 fChain[i].x = xy[i].GetX();
                 fChain[i].y = xy[i].GetY();
      }
  else
     fChain = NULL;
}
//______________________________________________________________________________
TGWin32Marker::~TGWin32Marker(){
//*-*-*-*-*-*-*-*-*-*-*-*Default Destructor*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
//*-*                    ==================
  if (fChain) delete fChain;
}

//______________________________________________________________________________
int    TGWin32Marker::GetNumber(){return fNumNode;}
//______________________________________________________________________________
POINT *TGWin32Marker::GetNodes(){return fChain;}
//______________________________________________________________________________
int  TGWin32Marker::GetType(){return fMarkerType;}

//______________________________________________________________________________
void TGWin32Marker::SetMarker(int n, TPoint *xy, int type){

//*-* Did we have a chain ?

if (fMarkerType >= 2 && fNumNode != n){    // Yes, we had chain
       if (fChain) delete fChain;  // Delete the obsolete chain
       fChain = NULL;
}

//*-*  Create the new shaped marker

if (type >= 2) {
    if (!fChain) fChain = new POINT[n];
    for( int i = 0; i < n; i++ ) {
      fChain[i].x = xy[i].GetX();
      fChain[i].y = xy[i].GetY();
    }
}
else if (fChain) { delete fChain; fChain = NULL; }

fNumNode = n;
fMarkerType = type;

}
